Subject: Re: [BUG] Layerscape CAAM+kTLS+io_uring

From: Jakub Kicinski <[email-masked]>
Date: Thu, 5 May 2022 17:10:00 -0700

On Thu, 5 May 2022 21:20:46 +0200 Marc Kleine-Budde wrote:
> Hello,
> 
> no one seems to care about this problem. :/
> 
> Maybe too many components are involved, I'm the respective maintainers
> on Cc.
> 
> Cc += the CAAM maintainers
> Cc += the io_uring maintainers
> Cc += the kTLS maintainers
> 
> On 27.04.2022 10:20:40, Steffen Trumtrar wrote:
> > Hi all,
> > 
> > I have a Layerscape-1046a based board where I'm trying to use a
> > combination of liburing (v2.0) with splice, kTLS and CAAM (kernel
> > v5.17). The problem I see is that on shutdown the last bytes are
> > missing. It looks like io_uring is not waiting for all completions
> > from the CAAM driver.
> > 
> > With ARM-ASM instead of the CAAM, the setup works fine.  
> 
> What's the difference between the CAAM and ARM-ASM crypto? Without
> looking into the code I think the CAAM is asynchron while ARM-ASM is
> synchron. Is this worth investigating?

Sounds like
20ffc7adf53a ("net/tls: missing received data after fast remote close")